from pylab import *

print("")
print("*************************************")
print("*  Quantites de matiere et titrage  *")
print("*  Exercice 46 p. 108               *")
print("*  Equation de la reaction :        *")
print("*           Fe2+ + 2HO- --> Fe(HO)2 *")
print("************************Hatier 2020**")

print("")
print("Attention : le separateur decimal est le point")
print("")

### A MODIFIER : DONNEES ###
### Concentration de la solution titree en mol/L
c1=0.2
### Volume de solution titree en mL
V1=20.0
### Concentration de la solution titrante en mol/L
c=1.0
### Volume maximal affiche en mL
Vmax=25.0
### Volume d'eau ajoute en mL
Veau=150

### NE PAS MODIFIER : CALCULS ###
### Calcul de la quantite de matiere apportee de reactif titre en mol
n1=c1*V1/1000
### Calcul du volume equivalent en mL
Ve=2*c1*V1/c

### NE PAS MODIFIER : INITIALISATION
### Volume de solution titrante verse
V=[0]
### Quantite de matiere des especes ioniques en mol
nsulfate=[n1]
nfer=[n1]
nsodium=[0]
nhydroxyde=[0]
### Pas en volume en mL
dV=0.5
### Increment
i=0

### A MODIFIER : BOUCLE
### Rappels : L[-1] renvoie le dernier element de la liste L
### et L.append(X) ajoute X a la fin de la liste L
while V[-1]<Ve:
	i=i+1
	V.append(V[-1]+dV)
	xmax=
	nfer.append()
	nsulfate.append()
	nsodium.append()
	nhydroxyde.append()

while V[-1]<Vmax:
	i=i+1
	V.append(V[-1]+dV)
	nfer.append()
	nsulfate.append()
	nsodium.append()
	nhydroxyde.append()

### NE PAS MODIFIER ###

### Ecriture des resultats
print("")
print("Volume equivalent :",round(Ve,2),"mL")
xlim(0,Vmax)

### Conductivites molaires ioniques en S.m2/mol
lsulfate=16.0e-3
lfer=10.8e-3
lsodium=5.0e-3
lhydroxyde=19.8e-3

### Initialisations Vtot en m3, sigma en S/m
Vtot=[]
sigma=[]

for i in range(len(V)):
	Vtot.append((V[i]+V1+Veau)/1e6)
	sigma.append((lsulfate*nsulfate[i]+lfer*nfer[i]+lsodium*nsodium[i]+lhydroxyde*nhydroxyde[i])/Vtot[i])
xlabel("V (mL)")
ylabel("σ (S/m)")
plot(V,sigma)
show()
